<?php
/**
 * Description of Ajax
 *
 * @author carlos
 */
class ProjectAjax extends ProjectRepository {
    
    public function getResponse($request, $options) {
        return $this->$request($options);
    }
    
    public function getTranslation($options){
        $msj = $options['msj'];
        
        return array(
            'response'=>true,
            'translation'=>$this->_getTranslation($msj)
                );
    }    
    
    public function saveComments($options){
        
        if(parent::saveComments($options)){
            return array(
                'response'=>true
            );
        }        
        
        $this->flashmessenger->addMessage(array('danger'=>'Error al tratar de guardar comentario. Intenta nuevamente.'));
        return array(
            'response'=>false,
            'msg'=>$this->flashmessenger->getMessageString()
        );
    }
    
    public function saveDocuments($options){
        $project_id = $options['project_id'];
        $documents = $options['documents']['documents'];
        
        $uploadFiles = new UploadFile();
        $uploadFiles->setTempFolder(ROOT."/app/resources/docs/discussions/");
        $count  = count($documents['name']);
       
        if($count > 0){
            if($documents['name'][0] === ''){return true;}
            $tools = new Tools();
              
            for ($i = 0; $i <= $count-1; $i++) {
                $file = array(
                    'name' => $tools->getUniqidReal().".".$uploadFiles->getExtension($documents['name'][$i]),
                    'tmp_name' => $documents['tmp_name'][$i],
                    'size' => $documents['size'][$i],
                    'type' => $documents['type'][$i]
                );
 
                if(!$uploadFiles->uploadFile($file,null)){
                    $this->flashmessenger->addMessage(array('danger'=>$documents['name'][$i]."=>".$uploadFiles->getMessageError()));
                }else{
                   
                    $array = array(
                        'comment_id'=>0,
                        'input_file_name'=>$documents['name'][$i],
                        'system_file_name'=>$file['name'],
                        'created_at'=>date('Y-m-d H:i:s'),
                        'file_type'=>'project',
                        'reference'=>$project_id
                    );
 
                    EntityRepository::save($array, 'files');
                }
            }
        }      
        
        return array(
            'response'=>true
        );
    }
    
    public function deleteAtachedFile($options){
        $repoTask = new TaskRepository();
        $dataFile = $repoTask->getFileById($options['id_file']);
        if(EntityRepository::delete($options['id_file'], 'files')){
            unlink(PATH_DISCUSSIONS_DOCS.$dataFile['system_file_name']);
            return array(
                'response'=>true
            );
        }
        
        return array(
            'response'=>null
        );
    }
}