<?php
/**
 * Description of Ajax
 *
 * @author carlos
 */
class TaskAjax extends TaskRepository {
        
    public function getResponse($request, $options) {
        return $this->$request($options);
    }
    
    public function getTranslation($options){
        $msj = $options['msj'];
        
        return array(
            'response'=>true,
            'translation'=>$this->_getTranslation($msj)
                );
    }    
    
    public function saveComments($options){
        
        if(parent::saveComments($options)){
            return array(
                'response'=>true
            );
        }        
        
        $this->flashmessenger->addMessage(array('danger'=>'Error al tratar de guardar comentario. Intenta nuevamente.'));
        return array(
            'response'=>false,
            'msg'=>$this->flashmessenger->getMessageString()
        );
    }
    
    public function deleteAtachedFile($options){
        $repoTask = new TaskRepository();
        $dataFile = $repoTask->getFileById($options['id_file']);
        if(EntityRepository::delete($options['id_file'], 'files')){
            unlink(PATH_DISCUSSIONS_DOCS.$dataFile['system_file_name']);
            return array(
                'response'=>true
            );
        }
        
        return array(
            'response'=>null
        );
    }
    
    public function completeTask($options){
        if(parent::completeTask($options['id_task'])){
            return array(
                'response'=>true
            );
        }        
        
        $this->flashmessenger->addMessage(array('danger'=>'Error al tratar de completar tarea. Intenta nuevamente.'));
        return array(
            'response'=>false,
            'msg'=>$this->flashmessenger->getMessageString()
        );
    }
    
    public function viewTask($options){
        $taskRepo = new TaskRepository();
        $data = $taskRepo->getById($options['id_task']);
        $subtasks = $taskRepo->getSubtask($options['id_task']);
        $comments = $taskRepo->getComments($options['id_task']);
        $files = $taskRepo->getFilesGroupedByIdComment($options['id_task']);
        $_parents = $taskRepo->getParents($options['id_task']);    
        $parents = null;
        #voltear arreglo para mostrar primero tareas y luego subtareas
        while (count($_parents) > 0){
            $parents[] = array_pop($_parents);               
        }
        
        $taskForm = new TaskForm();
        $taskForm->populate($data);
        $taskForm->disabledAllElements();
        
        if($data['completed']==='1'){$taskForm->addOptionals('completed', array('checked'=>'checked'));}
        
        $customerAction = $this->_getTranslation('Editar ')." - ".$taskForm->getValueElement('name');
        $currentAction = '';
        $fafonts = 'fa-square-o';
        if($parents){
            foreach($parents as $parent){
                if($parent['completed']==='1'){$fafonts = "fa-check-square-o";}
                $currentAction .= "<li><a class='view_task' data-id_task='{$parent['id']}' style='cursor:pointer'><i class='fa $fafonts'></i> {$parent['name']}</a></li>";
            }
        }
        
        $string = "<div class='row'>";
        $string .= "<div class='col-lg-12'>";
        $string .= "<ol class='breadcrumb' style='background-color:#F8F8F8'>";
        $string .= $currentAction;        
        $string .= "</ol>";
        $string .= "</div>";
        $string .= "</div>";
        
        $string .= "<div class='col-md-6 col-xs-12'>";
        $string .= $taskForm->getElementString('customer_id');
        $string .= $taskForm->getElementString('project_id');
        $string .= $taskForm->getElementString('category_id');
        $string .= $taskForm->getElementString('name');
        $string .= "</div>";
        
        $string .= "<div class='col-md-6 col-xs-12'>";
        $string .= $taskForm->getElementString('contact');
        $string .= $taskForm->getElementString('due_at');
        $string .= $taskForm->getElementString('priority_id');
        $string .= $taskForm->getElementString('assigned_to');
        $string .= $taskForm->getElementString('completed');
        $string .= "</div>";        
                
        $string .= "<div class='col-md-12 col-xs-12 p-l-2'>";
        $string .= "<label>Descripcion</label>";
        $string .= "<p class='text-muted'><small>".$taskForm->getValueElement('description')."</small></p>";
        $string .= "</div>";
        
        $string .= "<div class='col-lg-12 col-md-12'>";
        $string .= "<h4 class='page-header p-b-2'>";
        $string .= $this->_getTranslation('Subtareas');
        $string .= "<a class='btn btn-sm btn-default pull-right' href='Task.php?action=subtask&id={$options['id_task']}'><i class='fa fa-plus'></i> <span class='hidden-xs'>{$this->_getTranslation('Agregar subtarea')}</span></a>";  
        $string .= "</h4>";
        $string .= "<div class='clear'></div>";
        $string .= "</div>";
        
        if($subtasks){
            $string .= "<div class='col-lg-12 col-md-12'>";
            $string .= "<ul class='subtasks'>";
                foreach ($subtasks as $subtask){
                    $faclass = 'fa-square-o';
                    $textClass = 'text-warning';
                    if($subtask['completed'] === '1'){$faclass = 'fa-check-square-o';$textClass = 'text-success';}
                    $string .= "<li><h4><a class='{$textClass} view_task' data-id_task='{$subtask['id']}' style='cursor:pointer'><i class='fa {$faclass}'></i> {$subtask['name']}</a></h4></li>";                   
                }
            $string .= "</ul>";
            $string .= "</div>";
        }   
        
        $string .= "<div class='col-md-12 col-xs-12 p-l-2'>";
        $string .= "<h4 class='page-header p-b-2'>{$this->_getTranslation('Comentarios')}
                        <a class='btn btn-sm btn-default pull-right' data-toggle='modal' data-target='#modalAddComment'><i class='fa fa-comment-o'></i> <span class='hidden-xs'>{$this->_getTranslation('Agregar comentario')}</span></a>  
                    </h4>";
        $string .= "</div>";
        
        if($comments){
            $string .= "<div class='col-lg-12 col-md-12 col-xs-12'>";
            $string .= "<ul class='comments'>";
                foreach($comments as $comment){
                $string .= "<li>";
                $string .= "<div class='comment_content'>";
                $string .= "<div class='fa fa-comment pull-right text-muted' style='color: #cdcdcd'></div>";
                $string .= "<strong>{$this->_getTranslation('Comentario')}</strong>";
                $string .= "<p>{$comment['content']}</p>";
                        if(key_exists($comment['id'], $files)){
                            $string .= "<ul class='files'>";
                                foreach($files[$comment['id']] as $key => $file){
                                    $string .= "<li>";
                                    $string .= "<span class='btn btn-xs btn-danger delete_attached_file' data-id_attached_file='{$file['id']}'><i class='fa fa-trash'></i></span>";
                                    $string .= "<a href='".ROOT_DISCUSSIONS_DOCS."{$file['system_file_name']}' target='_blank'>{$file['input_file_name']}</a>";
                                    $string .= "</li>";
                                }
                             $string .= "</ul>";
                        }
                        $string .= "<div class='small comment-footer'>";
                        $string .= "<i class='fa fa-calendar'></i>{$this->_getTranslation('Creado por')} <span class='text-primary'>{$comment['created_by_name']}</span><span>{$comment['created_at_formated']}</span>";
                        $string .= "</div>";
                    $string .= "</div>";
                $string .= "</li>";
                }
            $string .= "</ul>";
            $string .= "</div>";
        }
        
        return array(
            'response'=>true,
            'taskInformation'=>$string
        );
     
    }
    
    public function startTask($options){
        parent::startTask($options['task_id']);
        return array(
            'response'=>true
        );
    }
    
    public function pauseTask($options,$status = null){
        parent::pauseTask($options['task_id']);
        return array(
            'response'=>true
        );
    }
    
    public function restartTask($options){
        parent::restartTask($options['task_id']);
        return array(
            'response'=>true
        );
    }
    
    public function endTask($options){
         parent::endTask($options['task_id']);
        return array(
            'response'=>true
        );
    }
}