<?php
/**
 * Description of Ajax
 *
 * @author carlos
 */
class TicketAjax extends TicketRepository {
    
    public function getTranslation($options){
        $msj = $options['msj'];
        
        return array(
            'response'=>true,
            'translation'=>$this->_getTranslation($msj)
                );
    }    
    
    public function saveComments($options){
        if(parent::saveComments($options)){
            return array(
                'response'=>true
            );
        }        
        
        $this->flashmessenger->addMessage(array('danger'=>'Error al tratar de guardar comentario. Intenta nuevamente.'));
        return array(
            'response'=>false,
            'msg'=>$this->flashmessenger->getMessageString()
        );
    }
    
    public function deleteAtachedFile($options){
        $repoTask = new TaskRepository();
        $dataFile = $repoTask->getFileById($options['id_file']);
        if(EntityRepository::delete($options['id_file'], 'files')){
            unlink(PATH_DISCUSSIONS_DOCS.$dataFile['system_file_name']);
            return array(
                'response'=>true
            );
        }
        
        return array(
            'response'=>null
        );
    }
    
    public function completeTicket($options){
        if(parent::completeTicket($options['id_ticket'])){
            return array(
                'response'=>true
            );
        }        
        
        $this->flashmessenger->addMessage(array('danger'=>'Error al tratar de completar comentario. Intenta nuevamente.'));
        return array(
            'response'=>false,
            'msg'=>$this->flashmessenger->getMessageString()
        );
    }
    
    public function viewTicket($options){
        $ticketRepo = new TicketRepository();
        $data = $ticketRepo->getById($options['id_ticket']);
        $comments = $ticketRepo->getComments($options['id_ticket']);
        $files = $ticketRepo->getFilesGroupedByIdComment($options['id_ticket']);
        
        $ticketForm = new TicketForm();
        $ticketForm->populate($data);
        $ticketForm->disabledAllElements();
        
        if($data['completed']==='1'){$ticketForm->addOptionals('completed', array('checked'=>'checked'));}
        
        $string = "<div class='col-md-6 col-xs-12'>";
        $string .= $ticketForm->getElementString('customer_id');
        $string .= $ticketForm->getElementString('project_id');
        $string .= $ticketForm->getElementString('category_id');
        //$string .= $ticketForm->getElementString('description');
        $string .= "</div>";
        
        $string .= "<div class='col-md-6 col-xs-12'>";
        $string .= $ticketForm->getElementString('contact');
        $string .= $ticketForm->getElementString('due_at');
        $string .= $ticketForm->getElementString('priority_id');
        $string .= $ticketForm->getElementString('assigned_to');
        $string .= $ticketForm->getElementString('completed');
        $string .= "</div>";        
                
        $string .= "<div class='col-md-12 col-xs-12 p-l-2'>";
        $string .= "<label>Descripcion</label>";
        $string .= "<p class='text-muted'><small>".$ticketForm->getValueElement('description')."</small></p>";
        $string .= "</div>";
        
        $string .= "<div class='col-md-12 col-xs-12 p-l-2'>";
        $string .= "<h4 class='page-header'>{$this->_getTranslation('Comentarios')}
                        <a class='btn btn-sm btn-default pull-right' data-toggle='modal' data-target='#modalAddComment'><i class='fa fa-comment-o'></i> <span class='hidden-xs'>{$this->_getTranslation('Agregar comentario')}</span></a>  
                    </h4>";
        $string .= "</div>";
        
        if($comments){
            $string .= "<div class='col-lg-12 col-md-12 col-xs-12'>";
            $string .= "<ul class='comments'>";
                foreach($comments as $comment){
                $string .= "<li>";
                $string .= "<div class='comment_content'>";
                $string .= "<div class='fa fa-comment pull-right text-muted' style='color: #cdcdcd'></div>";
                $string .= "<strong>{$this->_getTranslation('Comentario')}</strong>";
                $string .= "<p>{$comment['content']}</p>";
                        if(key_exists($comment['id'], $files)){
                            $string .= "<ul class='files'>";
                                foreach($files[$comment['id']] as $key => $file){
                                    $string .= "<li>";
                                    $string .= "<span class='btn btn-xs btn-danger delete_attached_file' data-id_attached_file='{$file['id']}'><i class='fa fa-trash'></i></span>";
                                    $string .= "<a href='".ROOT_DISCUSSIONS_DOCS."{$file['system_file_name']}' target='_blank'>{$file['input_file_name']}</a>";
                                    $string .= "</li>";
                                }
                             $string .= "</ul>";
                        }
                        $string .= "<div class='small comment-footer'>";
                        $string .= "<i class='fa fa-calendar'></i>{$this->_getTranslation('Creado por')} <span class='text-primary'>{$comment['created_by_name']}</span><span>{$comment['created_at_formated']}</span>";
                        $string .= "</div>";
                    $string .= "</div>";
                $string .= "</li>";
                }
            $string .= "</ul>";
            $string .= "</div>";
        }
        
        return array(
            'response'=>true,
            'ticketInformation'=>$string
        );
       
    }
}