<?php 
class WastePDF {
    public function __construct($id,$createFile = null) {
        $tools = new Tools();
        $entity = new WasteEntity();
        $entity->setOptions($entity->getById($id));
        $entityData = $entity->getOptions();
        $entityData['id'] = $id;
        
        $entityDetalles = $entity->getShippingDetallesSaved($id);
        $empresa = new CompanyRepository();
        $empresaData = $empresa->getById(1);
        
        //Modifique metodo AddPage para qe ricibiera un tercer parametro, dicho parametro contiene el texto para a marca de agua.
        // para crear la marca de agua agregue las funciones Header y RotatedText en pdf.php
       $pdf = new PDF();
        if($entityData['status'] == '2'){
            $pdf->AddPage('L','','    Canceled');
        }else{
            $pdf->AddPage('L','');
        }       
        
        $pdf->SetFillColor(200,200,200);
        $pdf->Image(ROOT."/public/img/logo.png",10,2,40,0);
        
        $pdf->SetFont('Arial','B','14');
        $pdf->SetTextColor(128);
        $pdf->Cell(220, 7, "", '0', 0, 'R'); //<== margin left   
        $pdf->Cell(50, 7, "WASTE", '0', 1, 'R');    
        
        $pdf->Ln(3);
        $pdf->SetTextColor(0);        
        $pdf->SetFont('Arial','','8');
        /*
        $direccion = "\n\n\n".$empresaData['nombre']."\n".$empresaData['direccion']."\n";
        $direccion .= $empresaData['ciudad'].", ".$empresaData['estado']." ".$empresaData['codigopostal']."\n";
        if(trim($empresaData['telefonos'])!=''){$direccion .= "Phone: ".$empresaData['telefonos']."\n";}
        if(trim($empresaData['fax'])!=''){$direccion .= "Fax: ".$empresaData['fax']."\n";}
        if(trim($empresaData['email'])!=''){$direccion .= "Email: ".$empresaData['email']."\n";}
        */
        $pdf->Ln(7);
        $pdf->SetTextColor(0);            
        $pdf->SetFont('Arial','B','7');       
        
        $pdf->Cell(220, 4, "", '0', 0, 'L');
        $pdf->SetFont('Arial','B','7');
        $pdf->Cell(23, 4, "Waste #", '', 0, 'L');
        $pdf->SetFont('Arial','','7');
        $pdf->Cell(25, 4, $entityData['id'], '1', 1, 'C');
        
        $pdf->Cell(220, 4, "", '0', 0, 'L');
        $pdf->SetFont('Arial','B','7');
        $pdf->Cell(23, 4, "Waste Date", '0', 0, 'L');
        $pdf->SetFont('Arial','','7');
        $pdf->Cell(25, 4, $entity->getFormatedDate(), '1', 1, 'C');
        
        $pdf->Ln(5);        
        $pdf->SetFont('Arial','B','7');
        $pdf->Cell(60, 5, "CUSTOMER", 'B', 0, 'C');
        $pdf->Cell(30, 5, "LOT", 'B', 0, 'C');
        $pdf->Cell(35, 5, "ITEM", 'B', 0, 'C');
        $pdf->Cell(20, 5, "SIZE", 'B', 0, 'C'); 
        $pdf->Cell(15, 5, "PACKING", 'B', 0, 'C'); 
        $pdf->Cell(25, 5, "BRAND", 'B', 0, 'C'); 
        $pdf->Cell(15, 5, "QUALITY", 'B', 0, 'C'); 
        $pdf->Cell(20, 5, "COLOR", 'B', 0, 'C');
        $pdf->Cell(15, 5, "MAT", 'B', 0, 'C');
        $pdf->Cell(15, 5, "WEIGHT", 'B', 0, 'R');
        $pdf->Cell(15, 5, "BOXES", 'B', 1, 'R');
        
        $pdf->SetFont('Arial','','7');
        $totalCajas = 0;
        $pesoTotal = 0;
        $sumaPesoTotal = 0;
        $rows = 1;
        foreach($entityDetalles as $detalle){
            $totalCajas += $detalle['quantity_boxes'];
            $pesoTotal = $detalle['quantity_boxes']*$detalle['weight'];
            $sumaPesoTotal += $pesoTotal;
            
            $rows++;
            $x = $pdf->GetX();
            $y = $pdf->GetY();
            
            if($y > 250){
                $pdf->addPage('P');
                $pdf->SetFont('Arial','B','8');
                $pdf->Cell(60, 5, "CUSTOMER", 'B', 0, 'C');
                $pdf->Cell(30, 5, "LOT", 'B', 0, 'C');
                $pdf->Cell(35, 5, "ITEM", 'B', 0, 'C');
                $pdf->Cell(20, 5, "SIZE", 'B', 0, 'C'); 
                $pdf->Cell(15, 5, "PACKING", 'B', 0, 'C'); 
                $pdf->Cell(25, 5, "BRAND", 'B', 0, 'C'); 
                $pdf->Cell(15, 5, "QUALITY", 'B', 0, 'C'); 
                $pdf->Cell(20, 5, "COLOR", 'B', 0, 'C');
                $pdf->Cell(15, 5, "MAT", 'B', 0, 'C');
                $pdf->Cell(15, 5, "WEIGHT", 'B', 0, 'R');
                $pdf->Cell(15, 5, "BOXES", 'B', 0, 'R');
                $pdf->Cell(15, 5, "PALLETS", 'B', 1, 'R');

                $pdf->SetFont('Arial','','8');
                $x = $pdf->GetX();
                $y = $pdf->GetY();
            }
            
            $pdf->SetXY($x, $y); 
            $pdf->Multicell(60, 5, utf8_decode($detalle['customerName']), 'B','C');
            
            $h = $y - $pdf->GetY();
            if($h !== 0){$h = abs($h);}
            $x += 60;
            $pdf->SetXY($x, $y);
            $pdf->Multicell(30, $h, $detalle['lot'], 'B','C');            
            
            $h = $y - $pdf->GetY();
            if($h !== 0){$h = abs($h);}
            $x += 30;
            $pdf->SetXY($x, $y);
            $pdf->Multicell(35, $h, utf8_decode($detalle['descripcion']), 'B','C');
            
                     
            if(abs($y - $pdf->GetY()) !== 0){$h = abs($y - $pdf->GetY());}    
            $x += 35;  
            $pdf->SetXY($x, $y);
            $pdf->Multicell(20, $h, utf8_decode($detalle['sizeName']), 'B','C');
            
            
            if(abs($y - $pdf->GetY()) !== 0){$h = abs($y - $pdf->GetY());}
            $x += 20;
            $pdf->SetXY($x, $y);
            $pdf->Multicell(15, $h, utf8_decode($detalle['packingName']), 'B','C');
            
            if(abs($y - $pdf->GetY()) !== 0){$h = abs($y - $pdf->GetY());}
            $x += 15;
            $pdf->SetXY($x, $y);
            $pdf->Multicell(25, $h, utf8_decode($detalle['brandName']), 'B','C');
            
            if(abs($y - $pdf->GetY()) !== 0){$h = abs($y - $pdf->GetY());}
            $x += 25;
            $pdf->SetXY($x, $y);
            $pdf->Multicell(15, $h, utf8_decode($detalle['qualityName']), 'B','C');
            
            if(abs($y - $pdf->GetY()) !== 0){$h = abs($y - $pdf->GetY());}
            $x += 15;
            $pdf->SetXY($x, $y);
            $pdf->Multicell(20, $h, utf8_decode($detalle['colorName']), 'B','C');
            
            if(abs($y - $pdf->GetY()) !== 0){$h = abs($y - $pdf->GetY());}
            $x += 20;
            $pdf->SetXY($x, $y);
            $pdf->Multicell(15, $h, $detalle['madurityName'], 'B','C');
            
            if(abs($y - $pdf->GetY()) !== 0){$h = abs($y - $pdf->GetY());}
            $x += 15;
            $pdf->SetXY($x, $y);
            $pdf->Multicell(15, $h, $detalle['weight'], 'B','R');
            
            if(abs($y - $pdf->GetY()) !== 0){$h = abs($y - $pdf->GetY());}
            $x += 15;
            $pdf->SetXY($x, $y);
            $pdf->Multicell(15, $h, $detalle['quantity_boxes'], 'B','R');           
        } 
        
        $pdf->SetFont('Arial','B','7');
        $pdf->Cell(235, 7,'TOTAL', 'B', 0, 'R');
        $pdf->Cell(15, 7,number_format($sumaPesoTotal,2), 'B', 0, 'R');
        $pdf->Cell(15, 7,number_format($totalCajas,2), 'B', 1, 'R');   
        
        $pdf->Ln(4);
        $pdf->SetFont('Arial','B','7');
        $pdf->Cell(100, 5,'Comments', 'B', 1, 'L');
        
        $pdf->Ln(1);
        $pdf->SetFont('Arial','','7');
        $line_height = 1;
        $width = 100;
        $text = '';    
        $height = (ceil(($pdf->GetStringWidth($text) / $width)) * $line_height);
        $pdf->Multicell(100,3,$entity->getComments(),'0',1);        
        
        if($createFile){
            $pdf->Output(ROOT."/app/resources/docs/temp_pdf/PFA-".$dataPFA['id'].".pdf","F");
        }else{
            $pdf->Output();
        }
    }
}