<?php
class HistoryEntity Extends HistoryRepository{
    private $options = array(
        'operation'=>null,
        'table'=>null,
        'parent_reference'=>null,
        'reference'=>null,
        'action'=>null,
        'id_pallet'=>null,
        'date_time'=>null,
        'user'=>null
    );
    
     private $history_tables = array(
        'manifest'=>array( 
            'operation'=>'Manifest',
            'parent_reference'=>'parent_reference',
            'id_pallet'=>'id_pallet'),#Cuando no son detalles esta param no exite, se agrega asi, para que no marque error
         
        'manifest_details'=>array( 
            'operation'=>'Manifest',
            'parent_reference'=>'id_manifest',
            'id_pallet'=>'id_pallet'),
         
        'receiving'=>array( 
            'operation'=>'Receiving',
            'parent_reference'=>'parent_reference',
            'id_pallet'=>'id_pallet'),
         
        'receiving_details'=>array( 
            'operation'=>'Receiving',
            'parent_reference'=>'id_receiving',
            'id_pallet'=>'id_pallet'),
         
        'shipping_request'=>array( 
            'operation'=>'Shipping Request',
            'parent_reference'=>'parent_reference',
            'id_pallet'=>'id_pallet'),
         
        'shipping_request_details'=>array( 
            'operation'=>'Shipping Request',
            'parent_reference'=>'id_shipping_request',
            'id_pallet'=>'id_pallet'),
         
        'manufacturing'=>array( 
            'operation'=>'Manufacturing',
            'parent_reference'=>'parent_reference',
            'id_pallet'=>'id_pallet'),
         
        'manufacturing_inputs'=>array( 
            'operation'=>'Manufacturing',
            'parent_reference'=>'id_manufacturing',
            'id_pallet'=>'id_pallet'),
         
        'manufacturing_outputs'=>array( 
            'operation'=>'Manufacturing',
            'parent_reference'=>'id_manufacturing',
            'id_pallet'=>'id_pallet'),
         
        'manufacturing_outputs_pallets'=>array( 
            'operation'=>'Manufacturing',
            'parent_reference'=>'id_manufacturing',
            'id_pallet'=>'id_pallet'),
         
         'shipping'=>array( 
            'operation'=>'Shipping',
            'parent_reference'=>'parent_reference',
            'id_pallet'=>'id_pallet'),
         
        'shipping_details'=>array( 
            'operation'=>'Shipping',
            'parent_reference'=>'id_shipping',
            'id_pallet'=>'id_pallet_inventory'),
    );
    
    public function setOptions($data){
      foreach ($this->options as $option => $value){
          if(isset($data[$option])){
            $this->options[$option] = $data[$option];
          }
      }
    }
  
    public function getOptions(){
        return $this->options;
    }
    
    public function setHistoryInventory($options){
         return $this->save($options);
    }
    
    
    public function setHistory($options){        
        if(!key_exists($options['table'], $this->history_tables)){
            return true;
        }        
        
       $params = $this->history_tables[$options['table']];
       
       $login = new Login();
       $data = $options['data'];
       if(!key_exists('parent_reference',$data)){$data['parent_reference'] = '_NULL';}
       if(!key_exists('id_pallet',$data)){$data['id_pallet'] = '_NULL';}
       if(!key_exists('modifications',$options)){$options['modifications'] = '_NULL';}
       
       $array = array(
            'operation'=>$params['operation'],
            'table_name'=>$options['table'],
            'parent_reference'=>$data[$params['parent_reference']],
            'reference'=>$options['id'],
            'action'=>$options['action'],
            'id_pallet'=>$data[$params['id_pallet']],
            'date_time'=>date('Y-m-d H:i:s'),
            'user'=>$login->getId()
       );
      
      switch($options['action']){
          case 'insert':
              $array['modifications'] = serialize($options['data']);
              break;
          
          case 'update':
              if(is_null($options['modifications'])){return true;}
              $array['modifications'] = serialize($options['modifications']);
              break;
          
          case 'delete':
              $array['modifications'] = serialize($options['data']);
              break;
      }
       
       return $this->save($array);
    }
}