<?php
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

class ProjectRepository extends EntityRepository {

    private $table = 'projects';
    public $flashmessenger = null;
    
    public function __construct() {
        if(!$this->flashmessenger instanceof FlashMessenger){
            $this->flashmessenger = new FlashMessenger();
        }
    }
    
    public function _getTranslation($text){
        $translator = new Translator();
        return $translator->_getTranslation($text);
    }
    
    public function save(array $data, $table = null) {
        if(is_array($data['customer_id']) && count($data['customer_id']) > 0){
            $data['customer_id'] = trim(implode(',', $data['customer_id']),',');
        }
        
        return parent::save($data, $this->table);
    }
    
    public function delete($id, $table = null) {
        return parent::delete($id, $this->table);
    }

    public function update($id, $data, $table = null) {    
        if(is_array($data['customer_id']) && count($data['customer_id']) > 0){
            $data['customer_id'] = trim(implode(',', $data['customer_id']),',');
        }
        
        return parent::update($id, $data, $this->table);
    }

    public function getById($id, $table = null,$selectAux = null) {
        return parent::getById($id, $this->table,$selectAux);
    }

    public function isUsedInRecord($id, array $buscarEn = null,$andWhere = null) {
        return null;
        return parent::isUsedInRecord($id, array('tasks' => 'category_id'));
    }
    
    public function getListSelectProjects($idProject = null){
        if($idProject !== null){ $idProject = " AND find_in_set(id,'$idProject')";}
        
        $query = "SELECT id,name "
                . "FROM $this->table "
                . "WHERE 1 = 1 $idProject ORDER BY name ASC";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $array = array();
            while($row = $result->fetch_object()){
                $array[$row->id] = $row->name; 
            }
            
            return $array;
        }
        
        return null;
    }
    
    public function getListProjects(){
        $query = "SELECT * FROM $this->table ORDER BY name ASC";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            return $this->resultToArray($result);
        }
        
        return null;
    }
    
    public function getPrimaryTasks($options){
        $taskRepo = new TaskRepository();
        return $taskRepo->getListTasks(array('project_id'=>$options['project_id'],'group_id'=>'1'));
    }
    
    public function getSecondaryTasks($options){
        $taskRepo = new TaskRepository();
        return $taskRepo->getListTasks(array('project_id'=>$options['project_id'],'group_id'=>'2'));
    }
    
    public function getTickets($options){
        $taskRepo = new TicketRepository();
        return $taskRepo->getListTickets(array('project_id'=>$options['project_id']));
    }
    
    public function customersStringToArray($customers){
        $arrayCustomers = array();
        $customers = explode(',', $customers);
        foreach($customers as $key => $propiertie){
            $arrayCustomers[$propiertie] = $propiertie;
        }
        return $arrayCustomers;
    }
    
    public function getCustomersByIds(array $customersId){
        $customerRepo = new CustomerRepository();
        $customers = array();
        foreach($customersId as $id => $value){
            $customerData = $customerRepo->getById($id);
            $customers[$id] = $customerData;
        }
        return $customers;
    }
    
    public function getFilesByProjectId($idProject){
        $query = "SELECT * FROM files WHERE file_type = 'project' AND reference = '$idProject'";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            return $result = $this->resultToArray($result);            
        }
        return null;
    }
}