<?php
class ReporteListasRepository extends EntityRepository {
    
    public function getOpenTicketTask($options){      
        $project_id = null;
        $customer_id = null;
        $days_before = null;
        
        if(isset($options['days_before']) && trim($options['days_before']) !== ''){
            # DATEDIFF(CURDATE(),due_at) me regresa nu mero necativo si aun no se vence.
            $days_before = " AND DATEDIFF(CURDATE(),due_at) > ({$options['days_before']} * -1) ";
        }
        if(isset($options['project_id']) && trim($options['project_id']) !== ''){$project_id = " AND find_in_set(project_id,'{$options['project_id']}')";} 
        if(isset($options['customer_id']) && trim($options['customer_id']) !== ''){$project_id = " AND find_in_set(customer_id,'{$options['customer_id']}')";} 
        
        $query = "SELECT * FROM (";
        
        $query .= "SELECT id,"
                . "'Task' as type,"
                . "name, "
                . "description,"
                . "due_at,"
                . "DATEDIFF(CURDATE(),due_at)as days_past_due," #si es negatico; significa los dias que faltan por vencerse
                . "priority_id,"
                . "fxGetCustomerName(customer_id)as customer_name,"
                . "fxGetProjectName(project_id)as project_name,"
                . "fxGetCategoryName(category_id)as category_name,"
                . "DATE_FORMAT(due_at,'%m/%d/%Y')as due_at_formated,"
                . "fxGetPriorityName(priority_id)as priority_name,"
                . "fxGetUserName(assigned_to_id)as assigned_to_name,"
                . "uuid() "
                . "FROM tasks "
                . "WHERE 1 = 1 "
                . "$project_id "
                . "$customer_id "
                . "$days_before ";
        
        $query  .= " UNION ";
        
        $query .= "SELECT id,"
                . "'Ticket' as type,"
                . "name,"
                . "description,"
                . "due_at,"
                . "DATEDIFF(CURDATE(),due_at)as days_past_due," #si es negatico; significa los dias que faltan por vencerse
                . "priority_id,"
                . "fxGetCustomerName(customer_id)as customer_name,"
                . "fxGetProjectName(project_id)as project_name,"
                . "fxGetCategoryName(category_id)as category_name,"
                . "DATE_FORMAT(due_at,'%m/%d/%Y')as due_at_formated,"
                . "fxGetPriorityName(priority_id)as priority_name,"
                . "fxGetUserName(assigned_to_id)as assigned_to_name,"
                . "uuid() "
                . "FROM tickets "
                . "WHERE 1 = 1 "
                . "$project_id "
                . "$customer_id "
                . "$days_before ";
        
        $query .= ")r ";
        $query .= "ORDER BY due_at ASC, priority_id ASC";       
        
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $result = $this->resultToArray($result);
            
            return array(
                'data'=>$result
            );
        }       
        return null;
    }
    
     public function getOpenTicketTaskByUser($options){
        $project_id = null;
        $customer_id = null;
        $days_before = null;
        
        if(isset($options['days_before']) && trim($options['days_before']) !== ''){
           # DATEDIFF(CURDATE(),due_at) me regresa nu mero necativo si aun no se vence.
            $days_before = " AND DATEDIFF(CURDATE(),due_at) > ({$options['days_before']} * -1) ";
        }
        
        if(isset($options['project_id']) && trim($options['project_id']) !== ''){$project_id = " AND find_in_set(project_id,'{$options['project_id']}')";} 
        if(isset($options['customer_id']) && trim($options['customer_id']) !== ''){$project_id = " AND find_in_set(customer_id,'{$options['customer_id']}')";} 
        
        $query = "SELECT *,SUM(tasks)as tasks FROM (";
        
        $query .= "SELECT COUNT(id)as tasks, "
                . "assigned_to_id,"
                . "fxGetUserName(assigned_to_id)as assigned_to_name "
                . "FROM tasks "
                . "WHERE 1 = 1 "
                . "$project_id "
                . "$customer_id "
                . "$days_before ";
        
        $query  .= " UNION ";
        
       $query .= "SELECT COUNT(id)as tasks, "
                . "assigned_to_id, "
                . "fxGetUserName(assigned_to_id)as assigned_to_name "
                . "FROM tickets "
                . "WHERE 1 = 1 "
                . "$project_id "
                . "$customer_id "
                . "$days_before ";
        
        $query .= ")r WHERE tasks > 0 ";
        $query .= "GROUP BY assigned_to_id";       
        
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $result = $this->resultToArray($result);
            
            return array(
                'data'=>$result
            );
        }       
        return null;
    }
        
     public function createFilterFecha($fechaInicio,$fechaFin,$campoFecha = null ){
        $fecha = null;
        $tools = new Tools();
        if($fechaInicio!=null){
            $fechaInicio = $tools->setFormatDateToDB($fechaInicio);
            if($fechaFin!=null){
                $fechaFin = $tools->setFormatDateToDB($fechaFin);
                $fecha .=" AND $campoFecha BETWEEN '{$fechaInicio}' AND '{$fechaFin}' ";
            }else{
                $fecha .=" AND $campoFecha BETWEEN '{$fechaInicio}' AND '{$fechaInicio}' ";
            }
        }elseif($fechaFin!=null){
            $fecha .=" AND $campoFecha BETWEEN '{$fechaFin}' AND '{$fechaFin}' ";
        }
        
        return $fecha;
    }
}