<?php
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

class TaskRepository extends EntityRepository {

    private $table = 'tasks';
    private $parents = null;
    public $flashmessenger = null;
    
    public function __construct() {
        if(!$this->flashmessenger instanceof FlashMessenger){
            $this->flashmessenger = new FlashMessenger();
        }
    }
    
    public function _getTranslation($text){
        $translator = new Translator();
        return $translator->_getTranslation($text);
    }
    
    public function save(array $data, $table = null) {
        $login = new Login();
        $tools = new Tools();
        $data['due_at'] = $tools->setFormatDateToDB($data['due_at']);
        $data['ticket_id'] = '1';
        
        if(is_null($data['completed']) || $data['completed'] ==='0'){
            $data['completed'] = 0;            
        }else{
            $data['completed'] = 1;
            $data['completed_by_id'] = $login->getId();
            $data['completed_at'] = date('Y-m-d H:i:s');
        }        
        if(is_null($data['bill']) || $data['bill'] ==='0'){$data['bill'] = 0;}else{$data['bill'] = 1;}
        if(is_null($data['recurrent']) || $data['recurrent'] ==='0'){$data['recurrent'] = 0;}else{$data['recurrent'] = 1;}    
        if(trim($data['recurrent_size']) === ''){unset($data['recurrent_size']);}   
        if(trim($data['parent_id']) === ''){unset($data['parent_id']);}   
        if(trim($data['ticket_id']) === ''){unset($data['ticket_id']);}          
        
        $result = parent::save($data, $this->table);
        $this->setLastInsertId($this->getInsertId());
        
        if($result && $data['assigned_to_id'] !== '0'){
            $this->mailingTask($this->getLastInsertId());
        }
        
        return $result;
    }
    
    public function delete($id, $table = null) {
        return parent::delete($id, $this->table);
    }

    public function update($id, $data, $table = null) {   
        $originData = $this->getById($id);
        $login = new Login();
        $tools = new Tools();
        $data['due_at'] = $tools->setFormatDateToDB($data['due_at']);        
        
        if(is_null($data['completed']) || $data['completed'] ==='0' ){
            $data['completed'] = 0;            
        }else{
            $data['completed'] = 1;
            $data['completed_by_id'] = $login->getId();
            $data['completed_at'] = date('Y-m-d H:i:s');
        }     
        if(is_null($data['bill']) || $data['bill'] ==='0'){$data['bill'] = 0;}else{$data['bill'] = 1;}
        if(is_null($data['recurrent']) || $data['recurrent'] ==='0'){$data['recurrent'] = 0;}else{$data['recurrent'] = 1;}    
        if(trim($data['recurrent_size']) === ''){unset($data['recurrent_size']);}   
        if(trim($data['parent_id']) === ''){unset($data['parent_id']);}     
        
        unset($data['discussion_id']);
        $rs = parent::update($id, $data, $this->table);
        
        if($rs && ($originData['assigned_to_id'] !== $data['assigned_to_id'])){
            $data['id'] = $id;
            $this->mailingTask($data);
        }
        
        return $rs;
    }

    public function getById($id, $table = null,$selectAux = null) {
        $selectAux = " fxGetProjectName(project_id)as project_name,"
                   . " fxGetCustomerName(customer_id)as customer_name, "
                   . " fxGetUserName(assigned_to_id)as assigned_to_name, "
                   . " fxGetCategoryName(category_id)as category_name, "
                   . " fxGetPriorityName(priority_id)as priority_name ";
        return parent::getById($id, $this->table,$selectAux);
    }

    public function isUsedInRecord($id, array $buscarEn = null,$andWhere = null) {
        return null;
        return parent::isUsedInRecord($id, array('tasks' => 'category_id'));
    }
    
    public function getListSelectTasks($idCategory = null){
        if($idCategory !== null){ $idCategory = " AND find_in_set(id,'$idCategory')";}
        
        $query = "SELECT id,description,type "
                . "FROM $this->table "
                . "WHERE 1 = 1 $idCategory ORDER BY name ASC";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $array = array();
            while($row = $result->fetch_object()){
                $array[$row->id] = $row->descripcion; 
            }
            
            return $array;
        }
        
        return null;
    }
    
    public function getListTasks($options = null){
        $project_id = null;
        $group_id = null; // 1=Primaria  2=Secundaria
        $status = null;

        if(trim($options['project_id']) !== ''){$project_id = " AND find_in_set(project_id,'{$options['project_id']}')";}
        if(trim($options['group_id']) !== ''){$group_id = " AND group_id = '{$options['group_id']}' ";}
        if(isset($options['status']) && is_array($options['status']) && count($options['status']) > 0){
            $idsStatus = implode(',', $options['status']);
            $status = " AND find_in_set(status,'$idsStatus')";
        }  
        
        $query = "SELECT *,"
                . "fxGetCustomerName(customer_id)as customer_name,"
                . "fxGetProjectName(project_id)as project_name,"
                . "fxGetCategoryName(category_id)as category_name,"
                . "DATE_FORMAT(due_at,'%m/%d/%Y')as due_at_formated,"
                . "fxGetPriorityName(priority_id)as priority_name,"
                . "fxGetUserName(assigned_to_id)as assigned_to_name "
                . "FROM $this->table "
                . "WHERE 1 = 1 "
                . "$project_id "
                . "$group_id "
                . "$status "
                . "ORDER BY due_at ASC, priority_id ASC";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            return $this->resultToArray($result);
        }
        
        return null;
    }
    
    public function getListSelectPriority(){        
        $query = "SELECT id,name "
                . "FROM tasks_priority_code "
                . "WHERE 1 = 1  ORDER BY name ASC";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $array = array();
            while($row = $result->fetch_object()){
                $array[$row->id] = $row->name; 
            }
            
            return $array;
        }
        
        return null;
    }
    
    public function getParents($idTask){
        $query = "SELECT *,IFNULL(parent_id,0)as parent_id  FROM $this->table WHERE id = '$idTask'";
        $result = $this->query($query);        
        
        if($result->num_rows > 0){
            $result = $this->resultToArray($result)[0];
            $this->parents[$result['id']] = $result;
            
            if($result['parent_id'] !== '0'){
                $this->getParents($result['parent_id']);
            } 
        }        
        
        return $this->parents;              
    }
    
    public function getSubtask($idTask){
        $query = "SELECT * FROM $this->table WHERE parent_id = '$idTask'";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $result = $this->resultToArray($result);
            return $result;
        }
        return null;
    }
    
    public function getComments($idTask){  
        $dataTask = $this->getById($idTask);
        $query = "SELECT *,"
                . "fxGetUserName(created_by_id)as created_by_name,"
                . "DATE_FORMAT(created_at,'%a %b %d, %Y at %H:%i %p')as created_at_formated "
                . "FROM discussions_details "
                . "WHERE discussion_id = '{$dataTask['discussion_id']}' "
                . "ORDER BY id DESC";
        $result = $this->query($query);
        
        if($result->num_rows >0){
            return $this->resultToArray($result);
        }
        return null;
    }
    
    public function getFilesGroupedByIdComment($idTask){
        $query = "SELECT * FROM files WHERE file_type = 'task' AND reference = '$idTask'";
        $result = $this->query($query);
        
        $files = array();
        if($result->num_rows > 0){
            $result = $this->resultToArray($result);            
            foreach($result as $row){
                $files[$row['comment_id']][] = $row;
            }
        }
        return $files;
    }
    
    public function saveComments($options){
        $id_task = $options['comments_id_task'];
        $content = $options['comments_content'];
        $documents = $options['documents']['comments_documents'];
        
        try{
            $this->startTransaction();
            
            $taskData = $this->getById($id_task);
            if(!isset($taskData['discussion_id']) || is_null($taskData['discussion_id'])){
                 parent::save(array('created_at'=>date('Y-m-d H:i:s')), 'discussions');
                 $discussion_id = parent::getInsertId();
            }else{
                $discussion_id = $taskData['discussion_id'];
                parent::update($discussion_id,array('updated_at'=>date('Y-m-d H:i:s')), 'discussions');
            }

            $login = new Login();
            $discussions_details = array(
                'discussion_id'=>$discussion_id,
                'content'=>$content,
                'created_at'=>date('Y-m-d H:i:s'),
                'created_by_id'=>$login->getId()
            );

            if(!parent::save($discussions_details, 'discussions_details')){
                $this->rollback();
                return null;
            }
            $comment_id = parent::getInsertId();
            
            if(!parent::update($id_task, array('discussion_id'=>$discussion_id), $this->table)){
                $this->rollback();
                return null;
            }

            $this->commit();
            
            $uploadFiles = new UploadFile();
            $uploadFiles->setTempFolder(ROOT."/app/resources/docs/discussions/");
            $count  = count($documents['name']);
            
            if($count > 0){
                if($documents['name'][0] === ''){return true;}
                $tools = new Tools();
                for ($i = 0; $i <= $count-1; $i++) {
                    $file = array(
                        'name' => $tools->getUniqidReal().".".$uploadFiles->getExtension($documents['name'][$i]),
                        'tmp_name' => $documents['tmp_name'][$i],
                        'size' => $documents['size'][$i],
                        'type' => $documents['type'][$i]
                    );

                    if(!$uploadFiles->uploadFile($file,null)){
                        $this->flashmessenger->addMessage(array('danger'=>$documents['name'][$i]."=>".$uploadFiles->getMessageError()));
                    }else{
                        $array = array(
                            'comment_id'=>$comment_id,
                            'input_file_name'=>$documents['name'][$i],
                            'system_file_name'=>$file['name'],
                            'created_at'=>date('Y-m-d H:i:s'),
                            'file_type'=>'task',
                            'reference'=>$id_task
                        );

                        parent::save($array, 'files');
                    }
                }
            }           

            return true;
        } catch (Exception $ex) {
            $this->flashmessenger->addMessage(array('danger'=>$ex->getMessage()));
            return null;
        }      
    }
    
    public function getFileById($idFile){
        $query = "SELECT * FROM files WHERE id = '$idFile'";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            return $this->resultToArray($result)[0];
        }
        return null;
    }
    
     public function completeTask($id){
        $login = new Login();
        $data = array(
                    'completed'=>'1',
                    'toggle_completed_by_id'=>$login->getId(),
                    'toggle_completed_at'=>date('Y-m-d H:i:s'),
                    'updated_by_id'=>$login->getId(),
                    'updated_at'=>date('Y-m-d H:i:s'),);
        
        return parent::update($id,$data,$this->table);
    }
    
    public function startTask($idLoadLine){
        $startTime = date('Y-m-d H:i:s');
        return $this->updateString(array('start'=>$startTime,'last_downtime'=>$startTime,'work_status'=>'2'), " id = '$idLoadLine'", $this->table);
    }
    
    public function pauseTask($idLoadLine,$status = null){
         /* Envio status cuando la uso desde esta clase en la function endTask */
        if($status == null){$status = '3';}
        $pauseTime = date('Y-m-d H:i:s');
        $originData = $this->getById($idLoadLine); 
        
        if($originData['time_worked'] =='' || $originData['time_worked'] == null || $originData['time_worked']=='00:00:00'){
            $query = "UPDATE $this->table SET "
                    . "time_worked = SEC_TO_TIME(TIMESTAMPDIFF(SECOND,last_downtime,'$pauseTime')),"
                    . "work_status = '$status' "
                    . "WHERE id = '$idLoadLine'";
            return $this->query($query);
        }else{
            $query = "UPDATE $this->table SET "
                    . "time_worked = ADDTIME(SEC_TO_TIME(TIMESTAMPDIFF(SECOND,last_downtime,'$pauseTime')),time_worked),"
                   . "work_status = '$status' "
                    . "WHERE id = '$idLoadLine'";
            return $this->query($query);
        }
       
    }
    
    public function restartTask($idLoadLine){     
         $startTime = date('Y-m-d H:i:s');
         return $this->updateString(array('last_downtime'=>$startTime,'work_status'=>'2'), " id = '$idLoadLine'", $this->table);       
    }
    
    public function endTask($idLoadLine){
        $endTime = date('Y-m-d G:i:s');
        $originData = $this->getById($idLoadLine);
        
        if($originData['work_status']=='4'){
            #si utilizo $this->restartProduction se va restartProduction de LoadLineAjax.
            return self::restartTask($idLoadLine,'5');
        }else{
            return $this->updateString(array('end'=>$endTime,'status'=>'5'), " id = '$idLoadLine'", $this->table);
        }       
    }
    
    public function mailingTask($options){   
         $dataTask = $this->getById($options['id']);
         
         $userRepo = new UserRepository();
         $userData = $userRepo->getById($dataTask['assigned_to_id']);
         
         $emailer = new Emailer();
         $emailer->sendEmail(array(
             'from_title'=>'A&A Project Manager',
             'to'=>$userData['email'],
             'subject'=>$this->_getTranslation('Tarea asignada a:  ').$dataTask['assigned_to_name'].' '.$dataTask['name'].' ['.$dataTask['project_name'].' - '.$dataTask['customer_name'].']',
             'message'=>  file_get_contents(ROOT_HOST."/View/Mailing/mailingTask.php?idTask={$dataTask['id']}"),
             'msg-success'=>'Alerta enviada correctamente.'
         ));
     }
}