<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

class UserRepository extends EntityRepository {

    private $table = 'users';

    public function save(array $data, $table = null) {
        $data['contrasena'] = MD5($data['contrasena']);
        if(is_array($data['id_customer']) && count($data['id_customer']) > 0){
            $data['id_customer'] = trim(implode(',', $data['id_customer']),',');
        }

        return parent::save($data, $this->table);
    }
    
    public function delete($id, $table = null) {
        return parent::delete($id, $this->table);
    }

    public function update($id, $data, $table = null) {
        if($data['contrasena']!='' && $data['contrasena']!=null){
            $data['contrasena'] = MD5($data['contrasena']);
        }else{
            unset($data['contrasena']);
        }
        
        if(is_array($data['id_customer']) && count($data['id_customer']) > 0){
            $data['id_customer'] = trim(implode(',', $data['id_customer']),',');
        }
        
        return parent::update($id, $data, $this->table);
    }

    public function getById($id, $table = null,$selectAux = null) {
        return parent::getById($id, $this->table,$selectAux);
    }

    public function isUsedInRecord($id, array $buscarEn = null,$andWhere = null) {
        return parent::isUsedInRecord($id, array());
    }

    public function getListRoles() {
        $select = "SELECT id,role FROM acl_roles";
        $result = $this->query($select);

        if ($result) {
            $array = array();
            while ($row = $result->fetch_assoc()) {
                $array[$row['id']] = $row['role'];
            }
            return $array;
        }
        return null;
    }
    
    public function getUsersByIds($ids){
        $select = "SELECT *,CONCAT(nombre,' ',apellido)as completeName FROM $this->table WHERE id IN($ids)";
        $result = $this->query($select);
        
        if($result){
            return $this->resultToArray($result);
        }
        
        return null;
    }
    
    public function getListSelectUsers() {
        $select = "SELECT * FROM $this->table ";
        $result = $this->query($select);

        if ($result) {
            $array = array();
            while ($row = $result->fetch_assoc()) {
                $array[$row['id']] = $row['usuario'];
            }
            return $array;
        }
        return null;
    }
    
     public function getListUsers() {
        $select = "SELECT *,"
                . "fxGetStatusName(status,'User') as statusName, "
                . "fxGetRoleName(role) as roleName "
                . "FROM $this->table ";
        
        $result = $this->query($select);

        if ($result) {
           return $this->resultToArray($result);
        }
        return null;
    }
    
    public function getListStatus(){
        $query = "SELECT * FROM codigo_status WHERE tipo = 'User'";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $array = array();
            foreach($result as $status){
                $array[$status['codigo']] = $status['descripcion'];
            }
            return $array;
        }
        return null;
    }
    
    public function customerStringToArray($customers){
        $arrayCustomers = array();
        $customers = explode(',', $customers);
        foreach($customers as $key => $customer){
            $arrayCustomers[$customer] = $customer;
        }
        return $arrayCustomers;
    }
}