<?php
/**
 * Description of DatosFacturacionForm
 *
 * @author carlos
 */

class CustomerForm extends Form {

    public function __construct() {
        $this->setActionForm('Customer.php');
        $this->setName('customer');
        $this->setClass('customer');
        $this->setMethod('post');
        $this->setDefaultFormElementsColSize('8');
        $this->setDefaultFormLabelsColSize('4');
        parent::__construct();
        $this->init();
    }

    public function init() {
        $this->addElement(array(
            'type' => 'text',
            'name' => 'name',
            'label'=>'Nombre',
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'last_name',
            'label'=>'Apellido',
            'required'=> false
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'address',
            'label'=>'Direccion',
            'required'=> false
        )); 
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'city',
            'label'=>'Ciudad',
            'required'=> false
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'state',
            'label'=>'Estado',
            'required'=> false
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'zip_code',
            'label'=>'Codigo postal',
            'value'=>'',
            'required'=> false
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'contact',
            'label'=>'Contacto',
            'required'=> false
        ));         
                
        $this->addElement(array(
            'type' => 'text',
            'name' => 'email',
            'label'=>'Correo electronico',
            'required'=> false
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'phone',
            'label'=>'Telefono',
            'required'=> false
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'fax',
            'label'=>'Fax',
            'required'=> false
        ));         
        
        $this->addElement(array(
            'type' => 'textarea',
            'name' => 'comments',
            'label'=>'Comentarios',
        ));
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'send',
            'value'=> $this->_getTranslation('Terminar'),
            'optionals'=>array(
                'onclick'=>"submit()"),
            'class'=>'btn btn-primary m-t-1'
        ));
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'cancelar',
            'value'=> $this->_getTranslation('Cancelar'),
            'optionals'=>array(
                'onclick'=>"document.location = '".ROOT_HOST."/Controller/Customer.php'"),
            'class'=>'btn btn-danger m-t-1'
        ));
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'btnSaveCustomer',
            'value'=> $this->_getTranslation('Guardar'),
            'class'=>'btn btn-primary',
            'optionals'=>array('onclick'=>'saveCustomer()'),
            'col-size-element'=>'12',
        ));
    }    
    public function getModalFormString(){
        $formString = "<div class='col-lg-6 col-md-6 col-xs-12'>";
        $formString .= $this->getElementString('name');
        $formString .= $this->getElementString('last_name');
        $formString .= $this->getElementString('address');
        $formString .= $this->getElementString('city');
        $formString .= $this->getElementString('state');
        $formString .= $this->getElementString('zip_code');        
        $formString .= "</div>";  
        
        $formString .= "<div class='col-lg-6 col-md-6 col-xs-12'>";
        $formString .= $this->getElementString('contact');
        $formString .= $this->getElementString('phone');
        $formString .= $this->getElementString('email');
        $formString .= $this->getElementString('fax');
        $formString .= $this->getElementString('comments');  
        $formString .= "</div>";  

        return $formString;
    }    
    
    public function populate($data){                     
        parent::populate($data);
    }
}