<?php
/**
 * Description of DatosFacturacionForm
 *
 * @author carlos
 */

class ProjectForm extends Form {

    public function __construct() {
        $this->setActionForm('Project.php');
        $this->setName('project');
        $this->setClass('project');
        $this->setMethod('post');
        $this->setDefaultFormElementsColSize('8');
        $this->setDefaultFormLabelsColSize('4');
        parent::__construct();
        $this->init();
    }

    public function init() {
        $this->addElement(array(
            'type' => 'text',
            'name' => 'name',
            'label'=>'Nombre',
            'required'=> true
        ));
        
        $append = "<span class = 'btn input-group-addon addCustomer' data-action='insert'><i class='fa fa-plus'></i></span>";
        $this->addElement(array(
            'type' => 'select multiple',
            'name' => 'customer_id',
            'label'=>'Cliente',
            'multiOptions'=>$this->getListCustomers(),
            'required'=> true,
            'append'=>$append
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'address',
            'label'=>'Direccion',
            'required'=> false
        )); 
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'city',
            'label'=>'Ciudad',
            'required'=> false
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'state',
            'label'=>'Estado',
            'required'=> false
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'zip_code',
            'label'=>'Codigo postal',
            'value'=>'',
            'required'=> false
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'contact',
            'label'=>'Contacto',
            'required'=> false
        ));         
                
        $this->addElement(array(
            'type' => 'text',
            'name' => 'email',
            'label'=>'Correo electronico',
            'required'=> false
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'phone',
            'label'=>'Telefono',
            'required'=> false
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'fax',
            'label'=>'Fax',
            'required'=> false
        ));         
        
        $this->addElement(array(
            'type' => 'textarea',
            'name' => 'comments',
            'label'=>'Comentarios',
        ));
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'send',
            'value'=> $this->_getTranslation('Terminar'),
            'optionals'=>array(
                'onclick'=>"submit()"),
            'class'=>'btn btn-primary m-t-1'
        ));
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'cancelar',
            'value'=> $this->_getTranslation('Cancelar'),
            'optionals'=>array(
                'onclick'=>"document.location = '".ROOT_HOST."/Controller/Customer.php'"),
            'class'=>'btn btn-danger m-t-1'
        ));
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'btnSaveCustomer',
            'value'=> $this->_getTranslation('Guardar'),
            'class'=>'btn btn-primary',
            'optionals'=>array('onclick'=>'saveCustomer()'),
            'col-size-element'=>'12',
        ));
    } 
    
    public function getListCustomers(){
        $repoCustomer = new CustomerRepository();
        $list = $repoCustomer->getListSelectClientes();
         
        $array = array();
        if($list){
            foreach($list as $key => $value){
                $array[$key] = $value;
            }
        }       
        return $array;    
    }
    
    public function populate($data){  
        if(isset($data['customer_id']) && $data['customer_id']!=null && is_array($data['customer_id'])){
            $customers = array();
            foreach($data['customer_id'] as $customer){$customers[$customer] = $customer;}
            $data['customer_id'] = $customers;
        }
        
        parent::populate($data);
    }
}