<?php
class TaskForm extends Form {

    public function __construct() {
        $this->setName('task');
        $this->setActionForm('Task.php');
        $this->setEnctype('multipart/form-data');
        $this->setClass('task');
        $this->setMethod('post');
        parent::__construct();
        $this->init();
    }

    public function init() {
        $this->addElement(array(
            'type'=>'hidden',     
            'name'=>'parent_id'
        ));
        
        $this->addElement(array(
            'type'=>'hidden',     
            'name'=>'project_name'
        ));
        
        $this->addElement(array(
            'type'=>'hidden',     
            'name'=>'customer_name'
        ));
        
        $this->addElement(array(
            'type'=>'hidden',     
            'name'=>'ticket_id'
        ));
        
        $this->addElement(array(
            'type'=>'hidden',     
            'name'=>'work_status'
        ));
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'customer_id',
            'label'=>'Cliente',
            'multiOptions'=>$this->getListCustomers(),
            'required'=> true
        ));
         
         $this->addElement(array(
            'type' => 'select',
            'name' => 'project_id',
            'label'=>'Empresa',
            'multiOptions'=>$this->getListProjects(),
            'required'=> false
        ));
          
        $this->addElement(array(
            'type' => 'select',
            'name' => 'group_id',
            'label'=>'Grupo',
            'multiOptions'=>array('1'=>'Tarea primaria','2'=>'Tarea secundaria'),
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'category_id',
            'label'=>'Categoria',
            'multiOptions'=>$this->getListCategories(),
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'name',
            'label'=>'Nombre',
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'due_at',
            'label'=>'Fecha entrega',
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'assigned_to_id',
            'label'=>'Asignado a',
            'multiOptions'=>$this->getListUsers(),
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'checkbox',
            'name' => 'completed',
            'label'=>'Completado',
            'value'=>'1',
            'class'=>'switch',
            'required'=> false
        ));
        
        $this->addElement(array(
            'type' => 'checkbox',
            'name' => 'bill',
            'label'=>'Facturar',
            'value'=>'1',
            'class'=>'switch',
            'required'=> false
        ));
        
        $this->addElement(array(
            'type'=>'text',     
            'name'=>'time_worked',
            'label'=>'Tiempo trabajado',
            'optionals'=>array('readonly'=>'readonly'),
        ));
        
        $this->addElement(array(
            'type' => 'checkbox',
            'name' => 'recurrent',
            'label'=>'Repetir',
            'class'=>'switch',
            'value'=>'1',
            'required'=> false
        ));
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'recurrent_interval',
            'label'=>'Cada',
            'multiOptions'=>$this->getListRecurrentInverval(),
            'required'=> false
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'recurrent_size',
            'label'=>'Por',
            'required'=>false
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'recurrent_start_date',
            'label'=>'Iniciar el',
            'required'=> false
        ));
        
         $this->addElement(array(
            'type' => 'textarea',
            'name' => 'description',
            'label'=>'Description',
            'required'=>false
        ));
         
         $this->addElement(array(
            'type' => 'select',
            'name' => 'priority_id',
            'label'=>'Prioridad',
            'multiOptions'=>$this->getListPriorities(),
            'required'=> true
        ));        
        
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'send',
            'value'=> $this->_getTranslation('Terminar'),
            'optionals'=>array(
                'onclick'=>"submit()"),
            'class'=>'btn btn-primary'
        ));
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'cancelar',
            'value'=> $this->_getTranslation('Cancelar'),
            'optionals'=>array(
            'onclick'=>"document.location = '".ROOT_HOST."/Controller/Task.php'"),
            'class'=>'btn btn-danger'
        ));        
    }
    
    public function getListCustomers(){
        $repoCustomer = new CustomerRepository();
        $list = $repoCustomer->getListSelectClientes();
         
        $array = array(''=>'Seleccionar una opcion...');
        if($list){
            foreach($list as $key => $value){
                $array[$key] = $value;
            }
        }       
        return $array;    
    }
    
    public function getListProjects(){
        $repoCustomer = new ProjectRepository();
        $list = $repoCustomer->getListSelectProjects();
         
        $array = array(''=>'Seleccionar una opcion...');
        if($list){
            foreach($list as $key => $value){
                $array[$key] = $value;
            }
        }       
        return $array;    
    }
    
    public function getListCategories(){
        $repository = new CategoryRepository();
        $list = $repository->getListSelectCategory();
         
        $array = array(''=>'Seleccionar una opcion...');
        if($list){
            foreach($list as $key => $value){
                $array[$key] = $value;
            }
        }       
        return $array;            
    }
     public function getListPriorities(){
        $repository = new TaskRepository();
        $list = $repository->getListSelectPriority();
         
        $array = array('0'=>'Seleccionar una opcion...');
        if($list){
            foreach($list as $key => $value){
                $array[$key] = $value;
            }
        }       
        return $array;            
    }
    
    public function getListUsers(){
        $repository = new UserRepository();
        $list = $repository->getListSelectUsers();
         
        $array = array('0'=>'Seleccionar una opcion...');
        if($list){
            foreach($list as $key => $value){
                $array[$key] = $value;
            }
        }       
        return $array;            
    }
    
    public function getListRecurrentInverval(){
        //$repository = new CategoryRepository();
        //$list = $repository->getListSelectCategory();
        $list = array('day'=>'Dia','week'=>'Semana','bi_week'=>'Quincena','month'=>'Mes','year'=>'Año');
        
        $array = array(''=>'Seleccionar una opcion...');
        if($list){
            foreach($list as $key => $value){
                $array[$key] = $value;
            }
        }       
        return $array;            
    }
    
    public function populate($data){
        $tools = new Tools();
        if(isset($data['due_at'])){
            $data['due_at'] = $tools->setFormatDateToForm($data['due_at']);
        }        
        
        $append = '';
        switch($data['work_status']){
            case '1':
                $append = "<span class = 'btn btn-default input-group-addon _workStatus' data-taskid='{$this->getId()}' data-action='Iniciar tarea' data-request='startTask'><i class='fa fa-play'></i> Iniciar tarea</span>";
                break;

            case '2':
                $append = "<span class = 'btn btn-default input-group-addon _workStatus' data-taskid='{$this->getId()}' data-action='Pausar tarea' data-request='pauseTask'><i class='fa fa-pause'></i> Pausar tarea</span>";
                break;  

            case '3':       
                $append = "<span class = 'btn btn-default input-group-addon _workStatus' data-taskid='{$this->getId()}' data-action='Reiniciar tarea' data-request='restartTask'><i class='fa fa-refresh'></i> Reiniciar tarea</span>";
                break;
        }
        
        $this->setPropiedad('time_worked', array('append'=>$append));
        
        parent::populate($data);
    }
}