<?php
class TicketForm extends Form {

    public function __construct() {
        $this->setName('ticket');
        $this->setActionForm('Ticket.php');
        $this->setEnctype('multipart/form-data');
        $this->setClass('ticket');
        $this->setMethod('post');
        parent::__construct();
        $this->init();
    }

    public function init() {        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'customer_id',
            'label'=>'Cliente',
            'multiOptions'=>$this->getListCustomers(),
            'required'=> true
        ));
         
         $this->addElement(array(
            'type' => 'select',
            'name' => 'project_id',
            'label'=>'Empresa',
            'multiOptions'=>$this->getListProjects(),
            'required'=> false
        ));
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'category_id',
            'label'=>'Categoria',
            'multiOptions'=>$this->getListCategories(),
            'required'=> true
        )); 
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'name',
            'label'=>'Nombre',
            'required'=> true
        ));
                
        $this->addElement(array(
            'type' => 'textarea',
            'name' => 'description',
            'label'=>'Description',
            'required'=>false
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'contact',
            'label'=>'Contacto',
            'required'=> false
        )); 
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'due_at',
            'label'=>'Fecha entrega',
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'assigned_to_id',
            'label'=>'Asignado a',
            'multiOptions'=>$this->getListUsers(),
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'checkbox',
            'name' => 'completed',
            'label'=>'Completado',
            'value'=>'1',
            'class'=>'switch',
            'required'=> false
        ));
         
         $this->addElement(array(
            'type' => 'select',
            'name' => 'priority_id',
            'label'=>'Prioridad',
            'multiOptions'=>$this->getListPriorities(),
            'required'=> true
        ));        
        
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'send',
            'value'=> $this->_getTranslation('Terminar'),
            'optionals'=>array(
                'onclick'=>"submit()"),
            'class'=>'btn btn-primary'
        ));
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'cancelar',
            'value'=> $this->_getTranslation('Cancelar'),
            'optionals'=>array(
            'onclick'=>"document.location = '".ROOT_HOST."/Controller/Ticket.php'"),
            'class'=>'btn btn-danger'
        ));        
    }
    
    public function getListCustomers(){
        $repoCustomer = new CustomerRepository();
        $list = $repoCustomer->getListSelectClientes();
         
        $array = array(''=>'Seleccionar una opcion...');
        if($list){
            foreach($list as $key => $value){
                $array[$key] = $value;
            }
        }       
        return $array;    
    }
    
    public function getListProjects(){
        $repoCustomer = new ProjectRepository();
        $list = $repoCustomer->getListSelectProjects();
         
        $array = array(''=>'Seleccionar una opcion...');
        if($list){
            foreach($list as $key => $value){
                $array[$key] = $value;
            }
        }       
        return $array;    
    }
    
    public function getListCategories(){
        $repository = new CategoryRepository();
        $list = $repository->getListSelectCategory();
         
        $array = array(''=>'Seleccionar una opcion...');
        if($list){
            foreach($list as $key => $value){
                $array[$key] = $value;
            }
        }       
        return $array;            
    }
     public function getListPriorities(){
        $repository = new TaskRepository();
        $list = $repository->getListSelectPriority();
         
        $array = array('0'=>'Seleccionar una opcion...');
        if($list){
            foreach($list as $key => $value){
                $array[$key] = $value;
            }
        }       
        return $array;            
    }
    
    public function getListUsers(){
        $repository = new UserRepository();
        $list = $repository->getListSelectUsers();
         
        $array = array('0'=>'Seleccionar una opcion...');
        if($list){
            foreach($list as $key => $value){
                $array[$key] = $value;
            }
        }       
        return $array;            
    }
    
    public function populate($data){
        $tools = new Tools();
        if(isset($data['due_at'])){
            $data['due_at'] = $tools->setFormatDateToForm($data['due_at']);
        }
        parent::populate($data);
    }
}