<?php
/**
 * Description of UsuarioForm
 *
 * @author carlos
 */

class UserForm extends Form {

    public function __construct() {
        $this->setActionForm('User.php');
        $this->setClass('usuario');
        $this->setMethod('post');
        $this->setDefaultFormElementsColSize('8');
        $this->setDefaultFormLabelsColSize('4');
        parent::__construct();
        $this->init();
    }

    public function init() {
        $this->addElement(array(
            'type' => 'text',
            'name' => 'usuario',
            'label'=>'Usuario',
            'required'=> true
        ));

        $this->addElement(array(
            'type' => 'password',
            'name' => 'contrasena',
            'label'=>'Contrasena',
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'nombre',
            'label'=>'Nombre',
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'apellido',
            'label'=>'Apellido paterno',
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'telefono',
            'label'=>'Telefono',
            'required'=> false
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'email',
            'label'=>'Email',
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'role',
            'label'=>'Role',
            'multiOptions' => $this->getListRoles(),
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'status',
            'label'=>'Status',
            'multiOptions' => $this->getListStatus(),
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'select multiple',
            'name' => 'id_customer',
            'label'=>'Cliente',
            'multiOptions'=>$this->fillListCliente(),
            'required'=>true,
        )); 
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'send',
            'value'=> $this->_getTranslation('Terminar'),
            'optionals'=>array(
                'onclick'=>"submit()"),
            'class'=>'btn btn-primary m-t-1'
        ));
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'cancelar',
            'value'=> $this->_getTranslation('Cancelar'),
            'optionals'=>array(
                'onclick'=>"document.location = '".ROOT_HOST."/Controller/User.php'"),
            'class'=>'btn btn-danger m-t-1'
        ));
    }
    
    public function getListRoles(){
        $repository = new UserRepository();
        $list = $repository->getListRoles();
         
        $array = array('0' => 'Seleccionar una opcion...');
        foreach($list as $key => $value){
            $array[$key] = $value;
        }
        return $array;
    }
    
    public function getListStatus(){
        $repository = new UserRepository();
        $list = $repository->getListStatus();
         
        $array = array('0'=>'Seleccionar una opcion...');
        if($list){
            foreach($list as $key => $value){
                $array[$key] = $value;
            }
        }       
        return $array;            
    }
    
    public function fillListCliente(){
        $repository = new CustomerRepository();
        $result = $repository->getListSelectClientes();
        if ($result) {
            $array = array();
            foreach ($result as $key => $value) {
                $array[$key] = $value;
            }
            return $array;
        }
    }
    
    public function populate($data){
        if(isset($data['id_customer']) && $data['id_customer']!=null && is_array($data['id_customer'])){
            $customers = array();
            foreach($data['id_customer'] as $customer){$customers[$customer] = $customer;}
            $data['id_customer'] = $customers;
        }
        
        parent::populate($data);
    }
    
    public function setEditForm(){
        $this->noRequired(array('contrasena'));
    }
}