<?php
/**
 * Description of Login
 *
 * @author carlos
 */
class Login extends LoginRepository {
    private $user = array();
    private $isLogged = null;
    
    public function __construct($options = null) {
        if(null === $options){
            if(isset($_SESSION['usuario'])){ 
                $this->user = $_SESSION['usuario'];
                $this->isLogged = true;
            }
        }else{
            $this->isLoginCorrect($options['usuario'], $_POST['contrasena']);
        }
    } 
       
    public function isLoginCorrect($user, $password) {
        $data = parent::isLoginCorrect($user, $password);
        
        if($data){
            $this->setUser($data);
            $this->isLogged = true;
        }
         return null;
    }    
    
    public function setUser($data){
        $this->user = $data;
        $this->setDefaultController();
        $_SESSION['usuario'] = $this->user;
    }
    
    private function setDefaultController(){
        switch($this->getRole()){
            default:
                    $this->user['defaultController'] = 'Home.php';
                break;
        }
    }
    
    public function getDefaultController(){
        return $this->user['defaultController'];
    }
    
    public function getId(){
        return $this->user['id'];
    }
    
    public function getUusario(){
        return $this->user['usuario'];
    }
    
    public function getNombreCompleto(){
        return $this->user['nombre']." ".$this->user['apellido'];
    }
    
    public function getRole(){
        return $this->user['role'];
    }    
        
    public function getCustomer(){
        return $this->user['id_customer'];
    }
    
    public function isLogged(){
        return $this->isLogged;
    }
    
    public function setCurrentController($controller){
        $this->user['controller'] = $controller;
    }
    
    public function getCurrentController(){
        return  $this->user['controller'];
    }
}