$(document).ajaxStart($.blockUI).ajaxStop($.unblockUI);

/**/
$(document).on('focus', '.select2', function (e) {
   if (e.originalEvent && $(this).find(".select2-selection--single").length > 0) {
   $(this).siblings('select').select2('open');  
  } 
});

/*Prevent users from submitting a form by hitting Enter */
/*
$(document).ready(function() {
  $(window).keydown(function(event){
    if(event.keyCode == 13) {
      event.preventDefault();
      return false;
    }
  });
});*/

$(document).ready(function() {
    $(".modal-dialog").draggable({
        handle: ".modal-header,.modal-body,.modal-footer"
    });
});

function number_format(number,decimals,dec_point,thousands_sep) {
    number  = number*1;//makes sure `number` is numeric value
    var str = number.toFixed(decimals?decimals:0).toString().split('.');
    var parts = [];
    for ( var i=str[0].length; i>0; i-=3 ) {
        parts.unshift(str[0].substring(Math.max(0,i-3),i));
    }
    str[0] = parts.join(thousands_sep?thousands_sep:',');
    return str.join(dec_point?dec_point:'.');
}

function fadeOutAlert(){
  window.setTimeout(function() {
    $('.alert').slideUp('slow', function(){
        $(this).remove();
    });
  }, 3500);
}

function addMsgFlashmessenger(tipo,msg,messengerId){
    $('#msg').remove();
    $('#'+messengerId).append("<div id='msg' class='alert alert-"+tipo+"'></div>");
    var btnClose = "<button type='button' class='close' data-dismiss='alert'>&times;</button>";
    $('#msg').html(btnClose+msg);
    fadeOutAlert();
}
function submit(formName){
    $('form[name='+formName+']').submit();
}

function clearForm(formName){
    $('form[name='+formName+']')[0].reset();
}

function _getTranslation(msj,callback){
    $.post('/Controller/Ajax.php', {
        action: 'ajax',
        request: 'getTranslation',
        msj:msj
            }, function(data) {
                callback(msj);
            }, 'json');
}

function _alert(msg,callbackOk){
    $.alert({ 
        title:"<i class='fa fa-info-circle'></i> Mensaje", 
        content:msg,
        columnClass: 'col-md-6 col-md-offset-3',
        buttons: {   
            ok: {
                text: "OK",
                btnClass: 'btn-default',
                keys: ['enter'],
                action: function(){
                     callbackOk();
                }
            }
        }                      
    });     
}

function confirmDelete(msg,link){  
    $.confirm({
            theme: 'material',
            columnClass: 'col-md-6 col-md-offset-3',
            icon: 'fa fa-trash',
            title: 'Eliminar registro',
            content: msg,
            buttons:{                
                cancel: {
                    text:'No',
                    btnClass: 'btn-default col-md-4 pull-right',
                    action: function(){
                       $(this).remove();
                    }
                },
                confirm: {
                    text: 'Si ',
                    btnClass: 'btn-primary col-md-4 pull-right',
                    action: function(){
                       document.location = link;
                    }
                }
            }
        });        
        return false;
}

function deleteRegistry(msg,link){     
     $.confirm({
            theme: 'material',
            columnClass: 'col-md-6 col-md-offset-3',
            icon: 'fa fa-trash',
            title: 'Eliminar registro',
            content: msg,
            buttons:{                
                cancel: {
                    text:'No',
                    btnClass: 'btn-default col-md-4 pull-right',
                    action: function(){
                       $(this).remove();
                    }
                },
                confirm: {
                    text: 'Si ',
                    btnClass: 'btn-primary col-md-4 pull-right',
                    action: function(){
                         document.location = link;
                    }
                }
            }
        });
        return null;
}

function confirmAction(callback){
    $.confirm({
        title: 'Confirmar accion !',
        icon: 'fa fa-key',
        content: '' +
        '<form action="" class="formName">' +
        '<div class="form-group">' +
        '<label>Ingresa usuario y contraseña para confirmar.</label>' +
        '<input id="user" type="text" placeholder="User" class="name form-control" required />' +
        '<input id="password" type="password" placeholder="Password" class="name form-control" required />' +
        '</div>' +
        '</form>',
        buttons: {
            formSubmit: {
                text: 'Submit',
                btnClass: 'btn-blue',
                action: function () {
                    $.post('/Controller/Ajax.php', {
                        action: 'ajax',
                        request: 'confirmAction',
                        user: $('#user').val(),
                        password: $('#password').val()
                    }, function(data) {
                        if (data.response){
                            callback();
                        }else{                            
                            $('#flashmessenger').html(data.msg); 
                            return false;
                        }     
                    }, 'json');
                }
            },
            cancel: function () {
                //close
            }
        }
    });
}

/* REPORTS */

function setParametrosReporte(name,output){
    $('#reporte').val(name).trigger('change');
    $('#output').val(output).trigger('change');
}

function setFilterReport(report){
    var reportName = $(report).data('reportname');
    $('#reporte').val(reportName);
    $.post('/Controller/Reports.php',{
        action: 'ajax',
        request: 'getFiltersReport',
        report: reportName
    },function(data){
        if(data.response){
            $('#filtersArea').html(data.filters);
            $('select').select2();
            $('#fechaInicio,#fechaFin').datetimepicker({format: 'MM/DD/YYYY'});      
        }
    },'json');
}

/* END REPORTS*/

/* TASKS */
function saveComments(callback){
    
    var formData = new FormData(document.getElementById("form_comments"));  
    formData.append('action','ajax');
    formData.append('request','saveComments');
   
    $.ajax({
        url: '/Controller/Task.php', 
        type: "post",
        dataType:  'text json',
        data: formData,
        cache: false,
        contentType: false,
        processData: false
       
    }).done(function(res){                   
        if(res.response){document.location.reload();}
        $('#flashmessenger-addComment').html(res.msg);    
    });        
}

function completeTask(id_task){
    $.post('/Controller/Task.php',{
        action: 'ajax',
        request: 'completeTask',
        id_task: id_task
    },function(data){
        if(data.response){
            document.location.reload();  
        }
        $('#flashmessenger-addComment').html(data.msg); 
    },'json');
}

function viewTask(id_task){
     $.post('/Controller/Task.php',{
        action: 'ajax',
        request: 'viewTask',
        id_task: id_task
    },function(data){
        if(data.response){
            $('#taskInformation').html(data.taskInformation);     
            $('#completed').simpleSwitch();
            $('#modalViewTask').modal('show');
        }
        $('#flashmessenger-taskInformation').html(data.msg); 
    },'json');
}
/* END TASKS */

/* TICKETS */
function saveCommentsTickets(callback){
    
    var formData = new FormData(document.getElementById("form_comments"));  
    formData.append('action','ajax');
    formData.append('request','saveComments');
   
    $.ajax({
        url: '/Controller/Ticket.php', 
        type: "post",
        dataType:  'text json',
        data: formData,
        cache: false,
        contentType: false,
        processData: false
       
    }).done(function(res){
        if(res.response){            
            if(callback){callback();}
        }
        $('#flashmessenger-addComment').html(res.msg);    
    });        
}

function completeTicket(id_ticket){
    $.post('/Controller/Ticket.php',{
        action: 'ajax',
        request: 'completeTicket',
        id_ticket: id_ticket
    },function(data){
        if(data.response){
            document.location.reload();  
        }
        $('#flashmessenger-addComment').html(data.msg); 
    },'json');
}

function viewTicket(id_ticket,callback){
     $.post('/Controller/Ticket.php',{
        action: 'ajax',
        request: 'viewTicket',
        id_ticket: id_ticket
    },function(data){
        if(data.response){
            $('#ticketInformation').html(data.ticketInformation); 
            $('select').select2();
            $('#modalViewTicket #completed').simpleSwitch();
            $('#modalViewTicket').modal('show');
            
            if(callback){callback();}
           
        }
        $('#flashmessenger-ticketInformation').html(data.msg); 
    },'json');
}
/* END TICKETS */

/* PROJECTS */
function saveDocuments(callback){
    var formData = new FormData(document.getElementById("form_documents"));  
    formData.append('action','ajax');
    formData.append('request','saveDocuments');
    
    var project_id = $('form[name=project] #id').val();
    formData.append('project_id',project_id);
   
    $.ajax({
        url: '/Controller/Project.php', 
        type: "post",
        dataType:  'text json',
        data: formData,
        cache: false,
        contentType: false,
        processData: false
       
    }).done(function(res){
        if(res.response){            
            if(callback){callback();}
        }
        $('#flashmessenger-addDocuments').html(res.msg);    
    });        
}
/* END PROJECTS*/

function deleteAtachedFile(id_file){ 
    $.confirm({
            theme: 'material',
            columnClass: 'col-md-6 col-md-offset-3',
            icon: 'fa fa-trash',
            title: 'Eliminar archivo',
            content: 'Desea eliminar este archivo ?',
            buttons:{                
                cancel: {
                    text:'No',
                    btnClass: 'btn-default col-md-4 pull-right',
                    action: function(){
                       $(this).remove();
                    }
                },
                confirm: {
                    text: 'Si ',
                    btnClass: 'btn-primary col-md-4 pull-right',
                    action: function(){
                       $.post('/Controller/Task.php',{
                            action: 'ajax',
                            request: 'deleteAtachedFile',
                            id_file: id_file
                        },function(data){
                            if(data.response){
                               document.location.reload();
                            }
                        },'json');
                    }
                }
            }
        });        
        return false;
}

/* MODALS FORMS */
function getStringForm(name,callback){
    $.post('/Controller/Ajax.php', {
        action: 'ajaxModalForms',
        request: 'getStringForm',
        name:name
    }, function(data) {
        if (data.response){ 
            callback(data.stringForm);
        }
    }, 'json');
}

/* CUSTOMERS MODAL FORM */
function setCustomerModal(action){ 
    getStringForm('customer',function(formString){
        $('#modalAddCustomer .modal-body').html(formString);
    });
   
    if(action==='insert'){        
        $('form[name=customer] #action').val(action); 
        $('#customerModalLabel').html('Agregar cliente');
        $('#modalAddCustomer').modal('show');
    }
    
    if(action==='edit'){
        if($('form[name=customer] #id').val() !== ''){
            setCustomerData();
            $('form[name=customer] #action').val(action);
            $('#customerModalLabel').html('Actualizar cliente');
            $('#modalAddCustomer').modal('show');
        }
    }
}

function saveCustomer(){
   var options = $('form[name=customer] input, form[name=customer] select,form[name=customer] hidden').serializeArray();
   var customerSelected = $('#customer_id').val();
   
   $.post('/Controller/Ajax.php', {
        action: 'ajaxModalForms',
        request: 'saveCustomer',
        options: options,
        idCustomer: $('form[name=customer] #id').val(),
        customerSelected: customerSelected
    }, function(data) {
        if (data.response){           
            $('#flashmessenger').html(data.message);            
            $('#modalAddCustomer').modal('hide');            
            clearForm('customer');
            fadeOutAlert();  

            $('#s2id_customer_id').select2('destroy');
            $('#customer_id').html(data.listCustomers);
            $('#customer_id').select2();
            setCustomerData();
        }else{
            $('#flashmessenger-addCustomer').html(data.message);
            $('#modalAddCustomer .modal-body').html(data.formString);
            fadeOutAlert();             
        }
    }, 'json');
}

function setCustomerData(){
    $.post('/Controller/Ajax.php', {
        action: 'ajaxModalForms',
        request: 'getCustomerInfo',
        id: $('form[name=customer] #id').val()
    }, function(data) {
        if (data.response){     
            for (var name in data.customerInfo) {
                $('form[name=customer] #'+name).val(data.customerInfo[name]);
            }            
        }
    }, 'json');
}

/* END CLIENTE*/

/* START PAUSE END TASKS */
function workStatusTask(line){
    var action = $(line).data('action');
    var task_id = $(line).data('taskid');
    var request = $(line).data('request'); 
    
    $.confirm({
            theme: 'material',
            columnClass: 'col-md-6 col-md-offset-3',
            icon: 'fa fa-exclamation-triangle',
            title: action,
            content: 'Desea ejecutar la accion '+action+' ?',
            buttons:{                
                cancel: {
                    text:'No',
                    btnClass: 'btn-default col-md-4 pull-right',
                    action: function(){
                       $(this).remove();
                    }
                },
                confirm: {
                    text: 'Si ',
                    btnClass: 'btn-primary col-md-4 pull-right',
                    action: function(){
                        $.post('/Controller/Task.php', {
                                action: 'ajax',
                                request: request,
                                task_id: task_id
                            }, function(data) {
                                if (data.response){
                                    document.location.reload();
                                }
                            }, 'json');
                    }
                }
            }
        });
}